<?php
/**
 * BuddyServ IRC Services
 * 
 * Server supported usermodes
 * 
 * @name UserModes
 * @author Raymond Lynk <me@raymondj.ca>
 * @copyright (C) 2010, Raymond Lynk
 * @link http://buddyserv.raymondj.ca
 * @package Ircd
 * @version $Id: usermodes.php 309 2009-11-12 07:09:01Z lynk $
 */

/*
 * 		 ______           __     __         _______                        
 * 		|   __ \.--.--.--|  |.--|  |.--.--.|     __|.-----.----.--.--.     
 * 		|   __ <|  |  |  _  ||  _  ||  |  ||__     ||  -__|   _|  |  |     
 * 		|______/|_____|_____||_____||___  ||_______||_____|__|  \___/      
 *  				    			   |_|                                 
 *                                                                         
 */
	
define('UMODE_OPERATOR',	0x00001); //o
define('UMODE_INVISIBLE',	0x00002); //i
define('UMODE_WALLOPS',		0x00004); //w
define('UMODE_SNOTICE',		0x00008); //s
define('UMODE_CLOAK',		0x00010); //x
define('UMODE_GLOBOPS',		0x00020); //z
define('UMODE_REGISTERED',	0x00040); //r
define('UMODE_REGPRIV',		0x00080); //R
define('UMODE_HIDE',		0x00100); //p
define('UMODE_ADMIN',		0x00200); //a
define('UMODE_NETADMIN',	0x00400); //N

$usermodes = array(
	'o'		=> UMODE_OPERATOR,
	'i'		=> UMODE_INVISIBLE,
	'w'		=> UMODE_WALLOPS,
	's'		=> UMODE_SNOTICE,
	'x'		=> UMODE_CLOAK,
	'z'		=> UMODE_GLOBOPS,
	'r'		=> UMODE_REGISTERED,
	'R'		=> UMODE_REGPRIV,
	'p'		=> UMODE_HIDE,
	'a'		=> UMODE_ADMIN,
	'N'		=> UMODE_NETADMIN);
?>